/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

#ifdef DEBUG
#include <iostream>
#define TRACE(x) { std::cout << "newt_lv2_instr: " << x << std::endl; }
#define TRACE1(x, a1) { std::cout << "newt_lv2_instr: " << x << " - " << a1 << std::endl; }
#define TRACE2(x, a1, a2) { std::cout << "newt_lv2_instr: " << x << " - " << a1 << ", " << a2 << std::endl; }
#define TRACEC1(x, a1, c) { static int count = 0; if (++count <= c) std::cout << "newt_lv2_instr: " << x << " - " << a1 << std::endl; }
#else
#define TRACE(x)
#define TRACE1(x, a1)
#define TRACE2(x, a1, a2)
#define TRACEC1(x, a1, c)
#endif

#endif // CONFIG_H_INCLUDED
