/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#include "newt_frame.h"
#include "config.h"

NewtFrame::NewtFrame()
{
    m_width = 10;
    m_height = 10;
//    set_shadow_type(Gtk::SHADOW_OUT);
//    modify_bg(Gtk::STATE_NORMAL, m_bgColor);
//    modify_bg(Gtk::STATE_ACTIVE, m_bgColor);
//    modify_bg(Gtk::STATE_SELECTED, m_bgColor);
//    queue_draw();
}

NewtFrame::~NewtFrame()
{
    //dtor
}

void NewtFrame::on_size_allocate(Gtk::Allocation& allocation)
{
    Glib::RefPtr<Gdk::Window> refGdkWindow = get_window();

    m_width = allocation.get_width();
    m_height = allocation.get_height();
    TRACE2("on_size_allocate", m_width, m_height);

    //Use the offered allocation for this container:
    set_allocation(allocation);

    if(refGdkWindow)
    {
        refGdkWindow->move_resize(allocation.get_x(), allocation.get_y(), m_width, m_height);
    }

    //get_child()->size_allocate(allocation);
}

bool NewtFrame::on_expose_event(GdkEventExpose* event)
{
    if (get_window() && event)
    {
        CtxPtr context = get_window()->create_cairo_context();

        context->rectangle(0, 0, m_width, m_height);
        context->clip();

        DrawBackground(context);
        DrawBorder(context);
    }

    return true;
}

void NewtFrame::DrawBorder(CtxPtr context)
{
    context->save();
    //context->set_line_width(2.0);
    context->set_source_rgb(1, 1, 1);
    context->move_to(0, 0);
    context->line_to(m_width, 0);
    context->line_to(m_width, m_height);
    context->line_to(0, m_height);
    context->line_to(0, 0);
    context->stroke();
    context->restore();
}

void NewtFrame::DrawBackground(CtxPtr context)
{
    context->save();
    context->set_source_rgb(.3, 0, 0);
    context->paint();
    context->restore();
}
